#include<bits/stdc++.h>
using namespace	std;
#define ll long long
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int n,sz=1,z=1,o,m=0;
	bool bl=true;
	set<int> st;
	cin>>n;
	int a[n];
	map<int,int> mp;
	for(int i=0;i<n;i++){
		cin>>a[i];
		mp[a[i]]++;
		st.insert(a[i]);
	}
	while(sz*2-1!=n){
		sz*=2,z++;
	}
	o=st.size();
	if(mp[*st.begin()]==z){
		for(auto i:st){
			m++;
			if(mp[i]>o-m+1){
				bl=0;
				break;
			}
		}
		if(bl){
			for(auto i:st){
				cout<<i<<' ';
			}
		}
		else{
			cout<<-1;
		}
	}
	else{
		cout<<-1;
	}
}